/*
 * DialGuard
 * Version 1.0
 * Copyright (C) 2000
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License; or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, 
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
 * GNU General Public License for more details.
 *
 * You can obtain a copy of the GNU General Public License from their
 * web site at http://www.gnu.org/copyleft/gpl.html -- or, you can 
 * write to the Free Software Foundation, Inc., 59 Temple Place - 
 * Suite 330, Boston, MA 02111-1307, USA.
 */ 
/*
 * This software attempts to protect against programs that offer 
 * some "Free" service, but instead disconnect your modem and dial 
 * a number in some foreign country. 
 * 
 * This software should display a message box each time some program
 * attempts to dial out using RasDial. 
 *
 * Unfortunately, due to the manner in which this program is implemented
 * there are some classes of programs which will not be capable of 
 * being caught.  If you have some good way of fixing this (hint, 
 * trying to hook CreateProcessA won't work), or manage to get this to
 * work under WindowsNT, please send me your fixes
 */
#include <windows.h>
#include <winnls.h>     /* CompareString */
#include <ras.h>        /* RAS function definitions */
#include <winnt.h>      /* PE-Format defines */


/*******************************************
 * 
 * Function typedefs.. the misery of using 
 * C for this!
 */
typedef DWORD (WINAPI *FUNC_RasDialA)(
		LPRASDIALEXTENSIONS lpRasDialExtensions,
		LPSTR lpszPhonebook,
		LPRASDIALPARAMS lpRasDialParams, 
		DWORD dwNotifierType,
		LPVOID lpvNotifier,
		LPHRASCONN lphRasConn );

typedef DWORD (WINAPI *FUNC_RasDialW)(
		LPRASDIALEXTENSIONS lpRasDialExtensions,
		LPSTR lpszPhonebook,
		LPRASDIALPARAMS lpRasDialParams, 
		DWORD dwNotifierType,
		LPVOID lpvNotifier,
		LPHRASCONN lphRasConn );

typedef HINSTANCE (WINAPI *FUNC_LoadLibrary) (
		LPCSTR lpLibFileName );

/*
 * P R O T O T Y P E S 
 */
int dll_patch(void);
int import_table_patch(HMODULE);

/*
 * L O C A L    D A T A
 * Unique to each copy of this DLL
 */
#pragma data_seg()
HHOOK   MyMessageHook = 0;                
char    * rasapi32 = "rasapi32.dll";
char    * kernel32 = "kernel32.dll";
const char * sharedString = "DialGuard Shared Mapping";
DWORD   * lpCount;

HINSTANCE me;
BOOLEAN IMadeThis;

#define INT3 0x90 /* change to CC for a breakpoint */

#define MAX_PATCH 100
DWORD   patch_count = 0;
DWORD   patches[MAX_PATCH];
DWORD   originals[MAX_PATCH];

FUNC_RasDialA func_RasDialA = NULL;
BYTE    patch_RasDialA[6] = { INT3, 0xE9, 0xFE, 0xFF, 0xFF, 0xFF };
BYTE    orig_RasDialA[6];

FUNC_RasDialW func_RasDialW = NULL;
BYTE    patch_RasDialW[6] = { INT3, 0xE9, 0xFE, 0xFF, 0xFF, 0xFF };
BYTE    orig_RasDialW[6];

FUNC_LoadLibrary func_LoadLibrary = NULL;

LRESULT CALLBACK DialAProc(HWND hdlg, UINT umsg, 
    WPARAM wparam, LPARAM lparam) {
    LPRASDIALPARAMSA lpRasDialParams = (LPRASDIALPARAMS)lparam;
    if (umsg == WM_INITDIALOG) {
	SetDlgItemText(hdlg ,1000 ,lpRasDialParams->szPhoneNumber);
	SetDlgItemText(hdlg ,1001 ,lpRasDialParams->szUserName);
	SetDlgItemText(hdlg ,1002 ,lpRasDialParams->szPassword);
	SetDlgItemText(hdlg ,1003 ,lpRasDialParams->szEntryName);
	SetWindowPos(hdlg ,NULL,0 ,0 , 0 , 0 , 
	    SWP_NOSIZE | SWP_NOZORDER | SWP_SHOWWINDOW ); 
	BringWindowToTop(hdlg);
    } 
    else if (umsg == WM_COMMAND) {
	 if ((LOWORD(wparam) == IDOK) || (LOWORD(wparam) == IDCANCEL))
	     EndDialog(hdlg, LOWORD(wparam));
    } else
	return FALSE; 
    return TRUE;
}

DWORD WINAPI my_RasDialA(LPRASDIALEXTENSIONS lpRasDialExtensions , 
    LPSTR lpszPhonebook ,LPRASDIALPARAMSA lpRasDialParams , 
    DWORD dwNotifierType ,LPVOID lpvNotifier ,LPHRASCONN lphRasConn ) {
    DWORD r;
    HANDLE cur_proc = GetCurrentProcess();
    int   result;

    InterlockedIncrement(lpCount);
/*
    MessageBox( NULL, lpRasDialParams->szUserName, 
	lpRasDialParams->szPassword ,MB_OK|MB_ICONINFORMATION );
*/    
    result = DialogBoxParam(me ,MAKEINTRESOURCE(101) ,NULL , 
	(DLGPROC)DialAProc ,(DWORD)lpRasDialParams);
    if (result == IDCANCEL) {
        InterlockedDecrement(lpCount);
	return ERROR_NOT_ENOUGH_MEMORY;
	/* sort of a lie, but it's the only documented return code */
    }
    (void)WriteProcessMemory(cur_proc ,func_RasDialA ,orig_RasDialA , 
	sizeof(orig_RasDialA) ,NULL);
    r = func_RasDialA(lpRasDialExtensions ,lpszPhonebook ,lpRasDialParams , 
	dwNotifierType ,lpvNotifier ,lphRasConn);
    (void)WriteProcessMemory(cur_proc ,func_RasDialA ,patch_RasDialA , 
	sizeof(patch_RasDialA) ,NULL);
    InterlockedDecrement(lpCount);
    return r;
}

DWORD WINAPI my_RasDialW(LPRASDIALEXTENSIONS lpRasDialExtensions , 
    LPSTR lpszPhonebook ,LPRASDIALPARAMSA lpRasDialParams , 
    DWORD dwNotifierType ,LPVOID lpvNotifier ,LPHRASCONN lphRasConn ) {
    DWORD r;
    HANDLE cur_proc = GetCurrentProcess();

    MessageBox( NULL, lpRasDialParams->szUserName, 
	lpRasDialParams->szPassword, MB_OK);
    (void)WriteProcessMemory(cur_proc ,func_RasDialW ,orig_RasDialW , 
	sizeof(orig_RasDialW) ,NULL);
    r = func_RasDialW(lpRasDialExtensions ,lpszPhonebook ,lpRasDialParams , 
	dwNotifierType ,lpvNotifier ,lphRasConn);
    (void)WriteProcessMemory(cur_proc ,func_RasDialW ,patch_RasDialW , 
	sizeof(patch_RasDialW) ,NULL);
    return r;
}

HINSTANCE WINAPI my_LoadLibrary(LPCSTR lpFileName) {
    HMODULE  h;

    InterlockedIncrement(lpCount);
    h = func_LoadLibrary(lpFileName);
    /* MessageBox(NULL ,lpFileName ,"LoadLibrary" ,MB_OK); */
    if (h) {
	dll_patch();
	(void)import_table_patch(h);
    }
    InterlockedDecrement(lpCount);
    return h;
}

#define MAX_LIBRARIES 100
int import_table_patch(HMODULE image_base) {
/* This function patches the current image's import table for the
 * functions that can't be patched in memory (usually because they are
 * above 2Gb).
 */
    HANDLE  cur_proc;
    char    filename[MAX_PATH];
    PIMAGE_DOS_HEADER pmz;
    PIMAGE_NT_HEADERS ppe;
    PIMAGE_OPTIONAL_HEADER popthdr;
    int     import_size;
    PIMAGE_IMPORT_DESCRIPTOR pimports;
    int      import_count;
    DWORD    *ptr;
    char     *pname;

    /* this keeps track of libraries already scanned for the target
     * symbols */
    HMODULE  libraries[MAX_LIBRARIES];
    int      head_idx = 0;      /* libraries already processed */
    int      tail_idx = 0;      /* add new libraries here */
    int      idx;               

    cur_proc = GetCurrentProcess();
    /* 
     * get the current process's filename...
     */
    GetModuleFileName(image_base ,filename ,sizeof(filename));
    /* MessageBox( NULL, filename, "Loading...", MB_OK|MB_ICONINFORMATION ); */
    /*
     * ... Which will provide the _real_ image base (usually 0x400000)
     */
    libraries[tail_idx++] = GetModuleHandle(filename);

    while (head_idx < tail_idx) {
	image_base = libraries[head_idx++];

	/* One should, to be strict, use "ReadProcessMemory" here.  
	 * These pages could have protections applied which would cause 
	 * a fault (bad news!).  */
	pmz = (PIMAGE_DOS_HEADER)image_base;
	if (pmz->e_magic != IMAGE_DOS_SIGNATURE) return 0x10; 
    
	ppe = (PIMAGE_NT_HEADERS)((BYTE *)image_base + pmz->e_lfanew);
	if (ppe->Signature != IMAGE_NT_SIGNATURE) return 0x20;
	if (ppe->FileHeader.SizeOfOptionalHeader == 0) return 0x30;    
	popthdr = (PIMAGE_OPTIONAL_HEADER)&ppe->OptionalHeader;
	if (popthdr->Magic != IMAGE_NT_OPTIONAL_HDR_MAGIC) return 0x40;
	import_size = popthdr->
	    DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].Size;
	if (import_size == 0) continue;
	pimports = (PIMAGE_IMPORT_DESCRIPTOR)((BYTE *)image_base + popthdr->
	    DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress);
	/*
	 * pimports points to an array of imports.  The documentation
	 * suggests it will be terminated by a sentinel entry (all 0's)
	 * but section size should work here... 
	 */
	import_count = import_size / sizeof(IMAGE_IMPORT_DESCRIPTOR);
	while (import_count--) {
	    HANDLE  hLibrary;
	    /* if this is zero, this library hasn't been linked yet */
	    if (pimports->TimeDateStamp == 0)
		break; /* <-- ok, just go to the next library */
	    if (!pimports->Name)  /* well, that's it */
		break;
	    pname = (char *)image_base + pimports->Name;   
	    /* Careful.. I don't want to increase the ref count on the
	     * library, so I can't use LoadLibrary */
	    hLibrary = GetModuleHandle(pname);
	    if (NULL != hLibrary) {
		for (idx = 0; idx < tail_idx; idx++) {
		    if (libraries[idx] == hLibrary) break;
		}
		if (idx == tail_idx) libraries[tail_idx++] = hLibrary;
	    }
	    /* 2 is for equality - CSTR_EQUAL is not defined.. */
	    if ( 2 == CompareString( LOCALE_USER_DEFAULT, 
		NORM_IGNORECASE | NORM_IGNOREWIDTH, pname, -1, 
		kernel32, -1) ) {
		HANDLE  hLibrary;
		DWORD   * newfunc_LoadLibrary;
	   
		/* Careful.. I don't want to increase the ref count on the
		 * library, so I can't use LoadLibrary */
		hLibrary = GetModuleHandle(pname);
		if (NULL == hLibrary) return 0x70;
		func_LoadLibrary = (FUNC_LoadLibrary)GetProcAddress(
		    hLibrary, "LoadLibraryA");
		if (!func_LoadLibrary) break;
		newfunc_LoadLibrary = (DWORD *)&my_LoadLibrary;
		ptr = (DWORD *)((BYTE *)image_base + 
		    (DWORD)pimports->FirstThunk);
		while (*ptr) {   
		    if (*ptr == (DWORD)func_LoadLibrary) {
			if (patch_count>= MAX_PATCH) {
			    /* MessageBox( NULL, "Hey!", "Patch Overflow", MB_OK|MB_ICONINFORMATION ); */
			    break;
			}

			originals[patch_count] = (DWORD)func_LoadLibrary;
			patches[patch_count++] = (DWORD)ptr;
			(void)WriteProcessMemory(cur_proc, ptr, 
			    &newfunc_LoadLibrary, 
			    sizeof(&my_LoadLibrary), NULL);
		    } 
		    ptr++;
		} /* while function imports */    
	    } /* if target DLL */          
	    pimports++;
	} /* while import blocks */
    } /* while more libraries */   
    return 0;    
}

int dll_patch(void) {
    HANDLE  cur_proc= GetCurrentProcess();
    HMODULE hLibrary;

    hLibrary = GetModuleHandle(rasapi32);
    if (NULL != hLibrary) {
	DWORD   * newfunc_RasDialA;
	DWORD   * newfunc_RasDialW;
	DWORD   delta;

	/* Ackbar!  I don't know why this is the case, but sometimes
	 * I will load a library, and this second load will overwrite
	 * the patch!  But, other times, this is not a good idea because
	 * it will overwrite the original with the patch */        
	if (func_RasDialA) {
	    BYTE tmp[6];  /* FIXME - Hardcoded */
	    int  i;
	    (void)ReadProcessMemory(cur_proc ,func_RasDialA ,tmp , 
		sizeof(tmp) ,NULL);
	    for (i = 0; i < sizeof(tmp); i++) {
		if (tmp[i] != patch_RasDialA[i])
		    break;
	    } /* Ok!  It's the patched version..  Forget this! */
	    if (i == sizeof(tmp)) {
		return 0;
	    }
	}

	func_RasDialA = (FUNC_RasDialA)GetProcAddress(hLibrary,"RasDialA");
	if (!func_RasDialA)return 0x20;
	func_RasDialW = (FUNC_RasDialW)GetProcAddress(hLibrary,"RasDialW");
	if (!func_RasDialW)return 0x20;

	newfunc_RasDialA = (DWORD *)&my_RasDialA;
	delta = (DWORD)newfunc_RasDialA - (DWORD)func_RasDialA - 6;
	*((DWORD *)&patch_RasDialA[2]) = delta;
	(void)ReadProcessMemory(cur_proc ,func_RasDialA ,orig_RasDialA , 
	    sizeof(orig_RasDialA) ,NULL);
	(void)WriteProcessMemory(cur_proc ,func_RasDialA ,patch_RasDialA , 
	    sizeof(patch_RasDialA) ,NULL);

	newfunc_RasDialW = (DWORD *)&my_RasDialW;
	delta = (DWORD)newfunc_RasDialW - (DWORD)func_RasDialW - 6;
	*((DWORD *)&patch_RasDialW[2]) = delta;
	(void)ReadProcessMemory(cur_proc ,func_RasDialW ,orig_RasDialW , 
	    sizeof(orig_RasDialW) ,NULL);
	(void)WriteProcessMemory(cur_proc ,func_RasDialW ,patch_RasDialW , 
	    sizeof(patch_RasDialW) ,NULL);
    } 
    return 0;    
}

LRESULT CALLBACK GetMsgProc(int code, WPARAM wParam, LPARAM lParam) {
/*
 * This callback does nothing, the real work is done by the DLL attach
 * routine and the function hooks  
 */
    return CallNextHookEx( MyMessageHook, code, wParam, lParam );
}


extern BOOL WINAPI _DllMainCRTStartup(HINSTANCE hinst ,
    DWORD reason ,LPVOID isStatic) {
    HANDLE hfile;

    if (reason == DLL_PROCESS_ATTACH) {
        hfile = CreateFileMapping((HANDLE)0xFFFFFFFF ,NULL ,
            PAGE_READWRITE ,0 ,4096 ,sharedString );
        lpCount = (DWORD *)MapViewOfFile(hfile ,FILE_MAP_ALL_ACCESS ,
            0 ,0 ,4);

	me = hinst;
	DisableThreadLibraryCalls(hinst);
	if (isStatic) {                    
	    if (MyMessageHook)   return FALSE;   
	    MyMessageHook = SetWindowsHookEx(WH_GETMESSAGE ,
		 (HOOKPROC)GetMsgProc ,hinst ,0 );   
	    IMadeThis = 1;
	} else {
            IMadeThis = 0;
            if (GetWindowLong(GetDesktopWindow(), GWL_HINSTANCE) != me) {
	        dll_patch();
	        import_table_patch(0);
            }
	}
    }
    else if (reason == DLL_PROCESS_DETACH) {
       if (IMadeThis && MyMessageHook) {                                      
	   UnhookWindowsHookEx( MyMessageHook );   
	   MyMessageHook = 0;
       } else {
	   char    filename[MAX_PATH];
	   HANDLE  cur_proc = GetCurrentProcess();
	   unsigned int     i;

	   GetModuleFileName( 0, filename, sizeof(filename) );
	   /* MessageBox( NULL, filename, "Unloading...", MB_OK|MB_ICONINFORMATION); */
	   if (func_RasDialA) WriteProcessMemory(cur_proc, func_RasDialA,
		   orig_RasDialA, sizeof(orig_RasDialA), NULL);
	   if (func_RasDialW) WriteProcessMemory(cur_proc, func_RasDialW,
		   orig_RasDialW, sizeof(orig_RasDialW), NULL);
	   for (i = 0; i < patch_count; i++) {
	       (void)WriteProcessMemory(cur_proc ,(void *)patches[i] ,
		   &originals[i] ,sizeof(DWORD) ,NULL );
	   }
	   patch_count = 0;
	}
    }
    return TRUE;
}

extern void StaticLoad(void)
{
}
